// constvar.h
#ifndef _DCGSCONSTVAR_H_
#define _DCGSCONSTVAR_H_
#include <stdio.h>
class expression;

typedef struct var {
	Const typeVar;
	union {
		long long longlongVal;
		unsigned long long ulongVal;
		long longVal;
		int intVal;
		short shortVal;
		char charVal;
		double doubleVal;
		float floatVal;
		char *stringVal;
		void **ptrVal;
		void *voidVal;
		expression *expressionVal;
		char **pstringVal;
		int *pintVal;
		int **ppintval;
		long *plongVal;
		float *pfloatVal;
		double *pdoubleVal;
		float **ppfloatVal;
		double **ppdoubleVal;
	} data;
} var;
class constvar {
public:
	var data;
	var prevData;
	expression *ExprVal;
	constvar();
	constvar(var inp);
	constvar(unsigned long long inp);
	constvar(long inp);
	constvar(int inp);
	constvar(short inp);
	constvar(char inp);
	constvar(double inp);
	constvar(float inp);
	constvar(char *inp);
	constvar(void **inp);
	constvar(expression *inp);
	int fprintf(FILE *f);
	int sprintf(char *f);
	int fprintf(FILE *f,char *fmt);
	int sprintf(char *f,char *fmt);
	int fprintf();
	double evalDouble();
	long evalLong();
	char *getType();
	Const typeof();
};

constvar &operator+(constvar &x, constvar &y);
constvar &operator-(constvar &x, constvar &y);
constvar &operator*(constvar &x, constvar &y);
constvar &operator/(constvar &x, constvar &y);
constvar &operator%(constvar &x, constvar &y);
constvar& operator<<(constvar &x, constvar &y);
constvar& operator>>(constvar &x, constvar &y);
constvar& operator<(constvar &x, constvar &y);
constvar& operator<=(constvar &x, constvar &y);
constvar& operator>(constvar &x, constvar &y);
constvar& operator>=(constvar &x, constvar &y);
constvar& operator==(constvar &x, constvar &y);
constvar& operator!=(constvar &x, constvar &y);
constvar& operator&(constvar &x, constvar &y);
constvar& operator^(constvar &x, constvar &y);
constvar& operator|(constvar &x, constvar &y);
constvar& operator&&(constvar &x, constvar &y);
constvar& operator||(constvar &x, constvar &y);

constvar& operator-(constvar &x);
constvar& operator+(constvar &x);
constvar& operator!(constvar &x);
constvar& operator~(constvar &x);
#endif

